import { HtmlDocument } from "./html";
import { Lexer, LexerType } from "./lexers";
import { SelectorGroup } from "./selector";
import { ParserItem, Queue, QueueItem } from "./types";
export declare const parseLexer: (input: string, lexer: Partial<Record<LexerType, Lexer>>, compress: boolean, initialMode?: string[]) => {
    queue: QueueItem[];
    mode: string[];
};
export declare const parsedHtmlLexer: Partial<Record<LexerType, Lexer>>;
export declare const parsedQueryLexer: Partial<Record<LexerType, Lexer>>;
export declare const createQueueFromItems: (lexerAtoms: QueueItem[]) => Queue;
export declare const checkIfNothingRemains: (lexerAtoms: QueueItem[], endQueue: Queue, parent: ParserItem) => void;
export declare const htmlParser: (input: string, compress: boolean) => HtmlDocument;
export declare const queryParser: (input: string) => SelectorGroup;
export declare const tryHtmlParser: (input: string, compress: boolean) => HtmlDocument | undefined;
export declare const tryQueryParser: (input: string) => SelectorGroup | undefined;
